<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>TestProtocolDeviations xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../testapidocs/org/apache/http/impl/client/cache/TestProtocolDeviations.html">View Javadoc</a></div><pre>

<a class="jxr_linenumber" name="1" href="#1">1</a>   <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="2" href="#2">2</a>   <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="3" href="#3">3</a>   <em class="jxr_comment"> * Licensed to the Apache Software Foundation (ASF) under one</em>
<a class="jxr_linenumber" name="4" href="#4">4</a>   <em class="jxr_comment"> * or more contributor license agreements.  See the NOTICE file</em>
<a class="jxr_linenumber" name="5" href="#5">5</a>   <em class="jxr_comment"> * distributed with this work for additional information</em>
<a class="jxr_linenumber" name="6" href="#6">6</a>   <em class="jxr_comment"> * regarding copyright ownership.  The ASF licenses this file</em>
<a class="jxr_linenumber" name="7" href="#7">7</a>   <em class="jxr_comment"> * to you under the Apache License, Version 2.0 (the</em>
<a class="jxr_linenumber" name="8" href="#8">8</a>   <em class="jxr_comment"> * "License"); you may not use this file except in compliance</em>
<a class="jxr_linenumber" name="9" href="#9">9</a>   <em class="jxr_comment"> * with the License.  You may obtain a copy of the License at</em>
<a class="jxr_linenumber" name="10" href="#10">10</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="11" href="#11">11</a>  <em class="jxr_comment"> *   <a href="http://www.apache.org/licenses/LICENSE-2.0" target="alexandria_uri">http://www.apache.org/licenses/LICENSE-2.0</a></em>
<a class="jxr_linenumber" name="12" href="#12">12</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="13" href="#13">13</a>  <em class="jxr_comment"> * Unless required by applicable law or agreed to in writing,</em>
<a class="jxr_linenumber" name="14" href="#14">14</a>  <em class="jxr_comment"> * software distributed under the License is distributed on an</em>
<a class="jxr_linenumber" name="15" href="#15">15</a>  <em class="jxr_comment"> * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY</em>
<a class="jxr_linenumber" name="16" href="#16">16</a>  <em class="jxr_comment"> * KIND, either express or implied.  See the License for the</em>
<a class="jxr_linenumber" name="17" href="#17">17</a>  <em class="jxr_comment"> * specific language governing permissions and limitations</em>
<a class="jxr_linenumber" name="18" href="#18">18</a>  <em class="jxr_comment"> * under the License.</em>
<a class="jxr_linenumber" name="19" href="#19">19</a>  <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="20" href="#20">20</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="21" href="#21">21</a>  <em class="jxr_comment"> * This software consists of voluntary contributions made by many</em>
<a class="jxr_linenumber" name="22" href="#22">22</a>  <em class="jxr_comment"> * individuals on behalf of the Apache Software Foundation.  For more</em>
<a class="jxr_linenumber" name="23" href="#23">23</a>  <em class="jxr_comment"> * information on the Apache Software Foundation, please see</em>
<a class="jxr_linenumber" name="24" href="#24">24</a>  <em class="jxr_comment"> * &lt;<a href="http://www.apache.org/&gt;." target="alexandria_uri">http://www.apache.org/&gt;.</a></em>
<a class="jxr_linenumber" name="25" href="#25">25</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="26" href="#26">26</a>  <em class="jxr_comment"> */</em>
<a class="jxr_linenumber" name="27" href="#27">27</a>  <strong class="jxr_keyword">package</strong> org.apache.http.impl.client.cache;
<a class="jxr_linenumber" name="28" href="#28">28</a>  
<a class="jxr_linenumber" name="29" href="#29">29</a>  <strong class="jxr_keyword">import</strong> java.util.Date;
<a class="jxr_linenumber" name="30" href="#30">30</a>  <strong class="jxr_keyword">import</strong> java.util.Random;
<a class="jxr_linenumber" name="31" href="#31">31</a>  
<a class="jxr_linenumber" name="32" href="#32">32</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpEntity;
<a class="jxr_linenumber" name="33" href="#33">33</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpEntityEnclosingRequest;
<a class="jxr_linenumber" name="34" href="#34">34</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpHost;
<a class="jxr_linenumber" name="35" href="#35">35</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpRequest;
<a class="jxr_linenumber" name="36" href="#36">36</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpResponse;
<a class="jxr_linenumber" name="37" href="#37">37</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpStatus;
<a class="jxr_linenumber" name="38" href="#38">38</a>  <strong class="jxr_keyword">import</strong> org.apache.http.ProtocolVersion;
<a class="jxr_linenumber" name="39" href="#39">39</a>  <strong class="jxr_keyword">import</strong> org.apache.http.client.ClientProtocolException;
<a class="jxr_linenumber" name="40" href="#40">40</a>  <strong class="jxr_keyword">import</strong> org.apache.http.client.methods.CloseableHttpResponse;
<a class="jxr_linenumber" name="41" href="#41">41</a>  <strong class="jxr_keyword">import</strong> org.apache.http.client.methods.HttpExecutionAware;
<a class="jxr_linenumber" name="42" href="#42">42</a>  <strong class="jxr_keyword">import</strong> org.apache.http.client.methods.HttpRequestWrapper;
<a class="jxr_linenumber" name="43" href="#43">43</a>  <strong class="jxr_keyword">import</strong> org.apache.http.client.protocol.HttpClientContext;
<a class="jxr_linenumber" name="44" href="#44">44</a>  <strong class="jxr_keyword">import</strong> org.apache.http.conn.routing.HttpRoute;
<a class="jxr_linenumber" name="45" href="#45">45</a>  <strong class="jxr_keyword">import</strong> org.apache.http.entity.ByteArrayEntity;
<a class="jxr_linenumber" name="46" href="#46">46</a>  <strong class="jxr_keyword">import</strong> org.apache.http.impl.cookie.DateUtils;
<a class="jxr_linenumber" name="47" href="#47">47</a>  <strong class="jxr_keyword">import</strong> org.apache.http.impl.execchain.ClientExecChain;
<a class="jxr_linenumber" name="48" href="#48">48</a>  <strong class="jxr_keyword">import</strong> org.apache.http.message.BasicHttpEntityEnclosingRequest;
<a class="jxr_linenumber" name="49" href="#49">49</a>  <strong class="jxr_keyword">import</strong> org.apache.http.message.BasicHttpRequest;
<a class="jxr_linenumber" name="50" href="#50">50</a>  <strong class="jxr_keyword">import</strong> org.apache.http.message.BasicHttpResponse;
<a class="jxr_linenumber" name="51" href="#51">51</a>  <strong class="jxr_keyword">import</strong> org.easymock.Capture;
<a class="jxr_linenumber" name="52" href="#52">52</a>  <strong class="jxr_keyword">import</strong> org.easymock.classextension.EasyMock;
<a class="jxr_linenumber" name="53" href="#53">53</a>  <strong class="jxr_keyword">import</strong> org.junit.Assert;
<a class="jxr_linenumber" name="54" href="#54">54</a>  <strong class="jxr_keyword">import</strong> org.junit.Before;
<a class="jxr_linenumber" name="55" href="#55">55</a>  <strong class="jxr_keyword">import</strong> org.junit.Ignore;
<a class="jxr_linenumber" name="56" href="#56">56</a>  <strong class="jxr_keyword">import</strong> org.junit.Test;
<a class="jxr_linenumber" name="57" href="#57">57</a>  
<a class="jxr_linenumber" name="58" href="#58">58</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="59" href="#59">59</a>  <em class="jxr_javadoccomment"> * We are a conditionally-compliant HTTP/1.1 client with a cache. However, a lot</em>
<a class="jxr_linenumber" name="60" href="#60">60</a>  <em class="jxr_javadoccomment"> * of the rules for proxies apply to us, as far as proper operation of the</em>
<a class="jxr_linenumber" name="61" href="#61">61</a>  <em class="jxr_javadoccomment"> * requests that pass through us. Generally speaking, we want to make sure that</em>
<a class="jxr_linenumber" name="62" href="#62">62</a>  <em class="jxr_javadoccomment"> * any response returned from our HttpClient.execute() methods is conditionally</em>
<a class="jxr_linenumber" name="63" href="#63">63</a>  <em class="jxr_javadoccomment"> * compliant with the rules for an HTTP/1.1 server, and that any requests we</em>
<a class="jxr_linenumber" name="64" href="#64">64</a>  <em class="jxr_javadoccomment"> * pass downstream to the backend HttpClient are are conditionally compliant</em>
<a class="jxr_linenumber" name="65" href="#65">65</a>  <em class="jxr_javadoccomment"> * with the rules for an HTTP/1.1 client.</em>
<a class="jxr_linenumber" name="66" href="#66">66</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="67" href="#67">67</a>  <em class="jxr_javadoccomment"> * There are some cases where strictly behaving as a compliant caching proxy</em>
<a class="jxr_linenumber" name="68" href="#68">68</a>  <em class="jxr_javadoccomment"> * would result in strange behavior, since we're attached as part of a client</em>
<a class="jxr_linenumber" name="69" href="#69">69</a>  <em class="jxr_javadoccomment"> * and are expected to be a drop-in replacement. The test cases captured here</em>
<a class="jxr_linenumber" name="70" href="#70">70</a>  <em class="jxr_javadoccomment"> * document the places where we differ from the HTTP RFC.</em>
<a class="jxr_linenumber" name="71" href="#71">71</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="72" href="#72">72</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../org/apache/http/impl/client/cache/TestProtocolDeviations.html">TestProtocolDeviations</a> {
<a class="jxr_linenumber" name="73" href="#73">73</a>  
<a class="jxr_linenumber" name="74" href="#74">74</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> ProtocolVersion HTTP_1_1 = <strong class="jxr_keyword">new</strong> ProtocolVersion(<span class="jxr_string">"HTTP"</span>, 1, 1);
<a class="jxr_linenumber" name="75" href="#75">75</a>  
<a class="jxr_linenumber" name="76" href="#76">76</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">int</strong> MAX_BYTES = 1024;
<a class="jxr_linenumber" name="77" href="#77">77</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">int</strong> MAX_ENTRIES = 100;
<a class="jxr_linenumber" name="78" href="#78">78</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">int</strong> entityLength = 128;
<a class="jxr_linenumber" name="79" href="#79">79</a>  
<a class="jxr_linenumber" name="80" href="#80">80</a>      <strong class="jxr_keyword">private</strong> HttpHost host;
<a class="jxr_linenumber" name="81" href="#81">81</a>      <strong class="jxr_keyword">private</strong> HttpRoute route;
<a class="jxr_linenumber" name="82" href="#82">82</a>      <strong class="jxr_keyword">private</strong> HttpEntity body;
<a class="jxr_linenumber" name="83" href="#83">83</a>      <strong class="jxr_keyword">private</strong> HttpEntity mockEntity;
<a class="jxr_linenumber" name="84" href="#84">84</a>      <strong class="jxr_keyword">private</strong> ClientExecChain mockBackend;
<a class="jxr_linenumber" name="85" href="#85">85</a>      <strong class="jxr_keyword">private</strong> HttpCache mockCache;
<a class="jxr_linenumber" name="86" href="#86">86</a>      <strong class="jxr_keyword">private</strong> HttpRequest request;
<a class="jxr_linenumber" name="87" href="#87">87</a>      <strong class="jxr_keyword">private</strong> CloseableHttpResponse originResponse;
<a class="jxr_linenumber" name="88" href="#88">88</a>  
<a class="jxr_linenumber" name="89" href="#89">89</a>      <strong class="jxr_keyword">private</strong> CachingExec impl;
<a class="jxr_linenumber" name="90" href="#90">90</a>  
<a class="jxr_linenumber" name="91" href="#91">91</a>      @Before
<a class="jxr_linenumber" name="92" href="#92">92</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> setUp() {
<a class="jxr_linenumber" name="93" href="#93">93</a>          host = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"foo.example.com"</span>);
<a class="jxr_linenumber" name="94" href="#94">94</a>  
<a class="jxr_linenumber" name="95" href="#95">95</a>          route = <strong class="jxr_keyword">new</strong> HttpRoute(host);
<a class="jxr_linenumber" name="96" href="#96">96</a>  
<a class="jxr_linenumber" name="97" href="#97">97</a>          body = makeBody(entityLength);
<a class="jxr_linenumber" name="98" href="#98">98</a>  
<a class="jxr_linenumber" name="99" href="#99">99</a>          request = <strong class="jxr_keyword">new</strong> BasicHttpRequest(<span class="jxr_string">"GET"</span>, <span class="jxr_string">"/foo"</span>, HTTP_1_1);
<a class="jxr_linenumber" name="100" href="#100">100</a> 
<a class="jxr_linenumber" name="101" href="#101">101</a>         originResponse = Proxies.enhanceResponse(make200Response());
<a class="jxr_linenumber" name="102" href="#102">102</a> 
<a class="jxr_linenumber" name="103" href="#103">103</a>         <strong class="jxr_keyword">final</strong> CacheConfig config = CacheConfig.custom()
<a class="jxr_linenumber" name="104" href="#104">104</a>                 .setMaxCacheEntries(MAX_ENTRIES)
<a class="jxr_linenumber" name="105" href="#105">105</a>                 .setMaxObjectSize(MAX_BYTES)
<a class="jxr_linenumber" name="106" href="#106">106</a>                 .build();
<a class="jxr_linenumber" name="107" href="#107">107</a> 
<a class="jxr_linenumber" name="108" href="#108">108</a>         <strong class="jxr_keyword">final</strong> HttpCache cache = <strong class="jxr_keyword">new</strong> BasicHttpCache(config);
<a class="jxr_linenumber" name="109" href="#109">109</a>         mockBackend = EasyMock.createNiceMock(ClientExecChain.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="110" href="#110">110</a>         mockEntity = EasyMock.createNiceMock(HttpEntity.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="111" href="#111">111</a>         mockCache = EasyMock.createNiceMock(HttpCache.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="112" href="#112">112</a> 
<a class="jxr_linenumber" name="113" href="#113">113</a>         impl = <strong class="jxr_keyword">new</strong> CachingExec(mockBackend, cache, config);
<a class="jxr_linenumber" name="114" href="#114">114</a>     }
<a class="jxr_linenumber" name="115" href="#115">115</a> 
<a class="jxr_linenumber" name="116" href="#116">116</a>     <strong class="jxr_keyword">private</strong> HttpResponse make200Response() {
<a class="jxr_linenumber" name="117" href="#117">117</a>         <strong class="jxr_keyword">final</strong> HttpResponse out = <strong class="jxr_keyword">new</strong> BasicHttpResponse(HTTP_1_1, HttpStatus.SC_OK, <span class="jxr_string">"OK"</span>);
<a class="jxr_linenumber" name="118" href="#118">118</a>         out.setHeader(<span class="jxr_string">"Date"</span>, DateUtils.formatDate(<strong class="jxr_keyword">new</strong> Date()));
<a class="jxr_linenumber" name="119" href="#119">119</a>         out.setHeader(<span class="jxr_string">"Server"</span>, <span class="jxr_string">"MockOrigin/1.0"</span>);
<a class="jxr_linenumber" name="120" href="#120">120</a>         out.setEntity(makeBody(128));
<a class="jxr_linenumber" name="121" href="#121">121</a>         <strong class="jxr_keyword">return</strong> out;
<a class="jxr_linenumber" name="122" href="#122">122</a>     }
<a class="jxr_linenumber" name="123" href="#123">123</a> 
<a class="jxr_linenumber" name="124" href="#124">124</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">void</strong> replayMocks() {
<a class="jxr_linenumber" name="125" href="#125">125</a>         EasyMock.replay(mockBackend);
<a class="jxr_linenumber" name="126" href="#126">126</a>         EasyMock.replay(mockCache);
<a class="jxr_linenumber" name="127" href="#127">127</a>         EasyMock.replay(mockEntity);
<a class="jxr_linenumber" name="128" href="#128">128</a>     }
<a class="jxr_linenumber" name="129" href="#129">129</a> 
<a class="jxr_linenumber" name="130" href="#130">130</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">void</strong> verifyMocks() {
<a class="jxr_linenumber" name="131" href="#131">131</a>         EasyMock.verify(mockBackend);
<a class="jxr_linenumber" name="132" href="#132">132</a>         EasyMock.verify(mockCache);
<a class="jxr_linenumber" name="133" href="#133">133</a>         EasyMock.verify(mockEntity);
<a class="jxr_linenumber" name="134" href="#134">134</a>     }
<a class="jxr_linenumber" name="135" href="#135">135</a> 
<a class="jxr_linenumber" name="136" href="#136">136</a>     <strong class="jxr_keyword">private</strong> HttpEntity makeBody(<strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">int</strong> nbytes) {
<a class="jxr_linenumber" name="137" href="#137">137</a>         <strong class="jxr_keyword">final</strong> byte[] bytes = <strong class="jxr_keyword">new</strong> byte[nbytes];
<a class="jxr_linenumber" name="138" href="#138">138</a>         (<strong class="jxr_keyword">new</strong> Random()).nextBytes(bytes);
<a class="jxr_linenumber" name="139" href="#139">139</a>         <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">new</strong> ByteArrayEntity(bytes);
<a class="jxr_linenumber" name="140" href="#140">140</a>     }
<a class="jxr_linenumber" name="141" href="#141">141</a> 
<a class="jxr_linenumber" name="142" href="#142">142</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> HttpRequest eqRequest(<strong class="jxr_keyword">final</strong> HttpRequest in) {
<a class="jxr_linenumber" name="143" href="#143">143</a>         org.easymock.EasyMock.reportMatcher(<strong class="jxr_keyword">new</strong> <a href="../../../../../../org/apache/http/impl/client/cache/RequestEquivalent.html">RequestEquivalent</a>(in));
<a class="jxr_linenumber" name="144" href="#144">144</a>         <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="145" href="#145">145</a>     }
<a class="jxr_linenumber" name="146" href="#146">146</a> 
<a class="jxr_linenumber" name="147" href="#147">147</a>     <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="148" href="#148">148</a> <em class="jxr_comment">     * "For compatibility with HTTP/1.0 applications, HTTP/1.1 requests</em>
<a class="jxr_linenumber" name="149" href="#149">149</a> <em class="jxr_comment">     * containing a message-body MUST include a valid Content-Length header</em>
<a class="jxr_linenumber" name="150" href="#150">150</a> <em class="jxr_comment">     * field unless the server is known to be HTTP/1.1 compliant. If a request</em>
<a class="jxr_linenumber" name="151" href="#151">151</a> <em class="jxr_comment">     * contains a message-body and a Content-Length is not given, the server</em>
<a class="jxr_linenumber" name="152" href="#152">152</a> <em class="jxr_comment">     * SHOULD respond with 400 (bad request) if it cannot determine the length</em>
<a class="jxr_linenumber" name="153" href="#153">153</a> <em class="jxr_comment">     * of the message, or with 411 (length required) if it wishes to insist on</em>
<a class="jxr_linenumber" name="154" href="#154">154</a> <em class="jxr_comment">     * receiving a valid Content-Length."</em>
<a class="jxr_linenumber" name="155" href="#155">155</a> <em class="jxr_comment">     *</em>
<a class="jxr_linenumber" name="156" href="#156">156</a> <em class="jxr_comment">     * <a href="http://www.w3.org/Protocols/rfc2616/rfc2616-sec4.html" target="alexandria_uri">http://www.w3.org/Protocols/rfc2616/rfc2616-sec4.html</a>#sec4.4</em>
<a class="jxr_linenumber" name="157" href="#157">157</a> <em class="jxr_comment">     *</em>
<a class="jxr_linenumber" name="158" href="#158">158</a> <em class="jxr_comment">     * 8/23/2010 JRC - This test has been moved to Ignore.  The caching client</em>
<a class="jxr_linenumber" name="159" href="#159">159</a> <em class="jxr_comment">     * was set to return status code 411 on a missing content-length header when</em>
<a class="jxr_linenumber" name="160" href="#160">160</a> <em class="jxr_comment">     * a request had a body.  It seems that somewhere deeper in the client stack</em>
<a class="jxr_linenumber" name="161" href="#161">161</a> <em class="jxr_comment">     * this header is added automatically for us - so the caching client shouldn't</em>
<a class="jxr_linenumber" name="162" href="#162">162</a> <em class="jxr_comment">     * specifically be worried about this requirement.</em>
<a class="jxr_linenumber" name="163" href="#163">163</a> <em class="jxr_comment">     */</em>
<a class="jxr_linenumber" name="164" href="#164">164</a>     @Ignore
<a class="jxr_linenumber" name="165" href="#165">165</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testHTTP1_1RequestsWithBodiesOfKnownLengthMustHaveContentLength() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="166" href="#166">166</a>         <strong class="jxr_keyword">final</strong> BasicHttpEntityEnclosingRequest post = <strong class="jxr_keyword">new</strong> BasicHttpEntityEnclosingRequest(<span class="jxr_string">"POST"</span>, <span class="jxr_string">"/"</span>,
<a class="jxr_linenumber" name="167" href="#167">167</a>                 HTTP_1_1);
<a class="jxr_linenumber" name="168" href="#168">168</a>         post.setEntity(mockEntity);
<a class="jxr_linenumber" name="169" href="#169">169</a> 
<a class="jxr_linenumber" name="170" href="#170">170</a>         replayMocks();
<a class="jxr_linenumber" name="171" href="#171">171</a> 
<a class="jxr_linenumber" name="172" href="#172">172</a>         <strong class="jxr_keyword">final</strong> HttpResponse response = impl.execute(route, HttpRequestWrapper.wrap(post));
<a class="jxr_linenumber" name="173" href="#173">173</a> 
<a class="jxr_linenumber" name="174" href="#174">174</a>         verifyMocks();
<a class="jxr_linenumber" name="175" href="#175">175</a> 
<a class="jxr_linenumber" name="176" href="#176">176</a>         Assert
<a class="jxr_linenumber" name="177" href="#177">177</a>                 .assertEquals(HttpStatus.SC_LENGTH_REQUIRED, response.getStatusLine()
<a class="jxr_linenumber" name="178" href="#178">178</a>                         .getStatusCode());
<a class="jxr_linenumber" name="179" href="#179">179</a>     }
<a class="jxr_linenumber" name="180" href="#180">180</a> 
<a class="jxr_linenumber" name="181" href="#181">181</a>     <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="182" href="#182">182</a> <em class="jxr_comment">     * Discussion: if an incoming request has a body, but the HttpEntity</em>
<a class="jxr_linenumber" name="183" href="#183">183</a> <em class="jxr_comment">     * attached has an unknown length (meaning entity.getContentLength() is</em>
<a class="jxr_linenumber" name="184" href="#184">184</a> <em class="jxr_comment">     * negative), we have two choices if we want to be conditionally compliant.</em>
<a class="jxr_linenumber" name="185" href="#185">185</a> <em class="jxr_comment">     * (1) we can slurp the whole body into a bytearray and compute its length</em>
<a class="jxr_linenumber" name="186" href="#186">186</a> <em class="jxr_comment">     * before sending; or (2) we can push responsibility for (1) back onto the</em>
<a class="jxr_linenumber" name="187" href="#187">187</a> <em class="jxr_comment">     * client by just generating a 411 response</em>
<a class="jxr_linenumber" name="188" href="#188">188</a> <em class="jxr_comment">     *</em>
<a class="jxr_linenumber" name="189" href="#189">189</a> <em class="jxr_comment">     * There is a third option, which is that we delegate responsibility for (1)</em>
<a class="jxr_linenumber" name="190" href="#190">190</a> <em class="jxr_comment">     * onto the backend HttpClient, but because that is an injected dependency,</em>
<a class="jxr_linenumber" name="191" href="#191">191</a> <em class="jxr_comment">     * we can't rely on it necessarily being conditionally compliant with</em>
<a class="jxr_linenumber" name="192" href="#192">192</a> <em class="jxr_comment">     * HTTP/1.1. Currently, option (2) seems like the safest bet, as this</em>
<a class="jxr_linenumber" name="193" href="#193">193</a> <em class="jxr_comment">     * exposes to the client application that the slurping required for (1)</em>
<a class="jxr_linenumber" name="194" href="#194">194</a> <em class="jxr_comment">     * needs to happen in order to compute the content length.</em>
<a class="jxr_linenumber" name="195" href="#195">195</a> <em class="jxr_comment">     *</em>
<a class="jxr_linenumber" name="196" href="#196">196</a> <em class="jxr_comment">     * In any event, this test just captures the behavior required.</em>
<a class="jxr_linenumber" name="197" href="#197">197</a> <em class="jxr_comment">     *</em>
<a class="jxr_linenumber" name="198" href="#198">198</a> <em class="jxr_comment">     * 8/23/2010 JRC - This test has been moved to Ignore.  The caching client</em>
<a class="jxr_linenumber" name="199" href="#199">199</a> <em class="jxr_comment">     * was set to return status code 411 on a missing content-length header when</em>
<a class="jxr_linenumber" name="200" href="#200">200</a> <em class="jxr_comment">     * a request had a body.  It seems that somewhere deeper in the client stack</em>
<a class="jxr_linenumber" name="201" href="#201">201</a> <em class="jxr_comment">     * this header is added automatically for us - so the caching client shouldn't</em>
<a class="jxr_linenumber" name="202" href="#202">202</a> <em class="jxr_comment">     * specifically be worried about this requirement.</em>
<a class="jxr_linenumber" name="203" href="#203">203</a> <em class="jxr_comment">     */</em>
<a class="jxr_linenumber" name="204" href="#204">204</a>     @Ignore
<a class="jxr_linenumber" name="205" href="#205">205</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testHTTP1_1RequestsWithUnknownBodyLengthAreRejectedOrHaveContentLengthAdded()
<a class="jxr_linenumber" name="206" href="#206">206</a>             <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="207" href="#207">207</a>         <strong class="jxr_keyword">final</strong> BasicHttpEntityEnclosingRequest post = <strong class="jxr_keyword">new</strong> BasicHttpEntityEnclosingRequest(<span class="jxr_string">"POST"</span>, <span class="jxr_string">"/"</span>,
<a class="jxr_linenumber" name="208" href="#208">208</a>                 HTTP_1_1);
<a class="jxr_linenumber" name="209" href="#209">209</a> 
<a class="jxr_linenumber" name="210" href="#210">210</a>         <strong class="jxr_keyword">final</strong> byte[] bytes = <strong class="jxr_keyword">new</strong> byte[128];
<a class="jxr_linenumber" name="211" href="#211">211</a>         (<strong class="jxr_keyword">new</strong> Random()).nextBytes(bytes);
<a class="jxr_linenumber" name="212" href="#212">212</a> 
<a class="jxr_linenumber" name="213" href="#213">213</a>         <strong class="jxr_keyword">final</strong> HttpEntity mockBody = EasyMock.createMockBuilder(ByteArrayEntity.<strong class="jxr_keyword">class</strong>).withConstructor(
<a class="jxr_linenumber" name="214" href="#214">214</a>                 <strong class="jxr_keyword">new</strong> Object[] { bytes }).addMockedMethods(<span class="jxr_string">"getContentLength"</span>).createNiceMock();
<a class="jxr_linenumber" name="215" href="#215">215</a>         org.easymock.EasyMock.expect(mockBody.getContentLength()).andReturn(-1L).anyTimes();
<a class="jxr_linenumber" name="216" href="#216">216</a>         post.setEntity(mockBody);
<a class="jxr_linenumber" name="217" href="#217">217</a> 
<a class="jxr_linenumber" name="218" href="#218">218</a>         <strong class="jxr_keyword">final</strong> Capture&lt;HttpRequestWrapper&gt; reqCap = <strong class="jxr_keyword">new</strong> Capture&lt;HttpRequestWrapper&gt;();
<a class="jxr_linenumber" name="219" href="#219">219</a>         EasyMock.expect(
<a class="jxr_linenumber" name="220" href="#220">220</a>                 mockBackend.execute(
<a class="jxr_linenumber" name="221" href="#221">221</a>                         EasyMock.eq(route),
<a class="jxr_linenumber" name="222" href="#222">222</a>                         EasyMock.capture(reqCap),
<a class="jxr_linenumber" name="223" href="#223">223</a>                         EasyMock.isA(HttpClientContext.<strong class="jxr_keyword">class</strong>),
<a class="jxr_linenumber" name="224" href="#224">224</a>                         EasyMock.&lt;HttpExecutionAware&gt;isNull())).andReturn(
<a class="jxr_linenumber" name="225" href="#225">225</a>                                 originResponse).times(0, 1);
<a class="jxr_linenumber" name="226" href="#226">226</a> 
<a class="jxr_linenumber" name="227" href="#227">227</a>         replayMocks();
<a class="jxr_linenumber" name="228" href="#228">228</a>         EasyMock.replay(mockBody);
<a class="jxr_linenumber" name="229" href="#229">229</a> 
<a class="jxr_linenumber" name="230" href="#230">230</a>         <strong class="jxr_keyword">final</strong> HttpResponse result = impl.execute(route, HttpRequestWrapper.wrap(post));
<a class="jxr_linenumber" name="231" href="#231">231</a> 
<a class="jxr_linenumber" name="232" href="#232">232</a>         verifyMocks();
<a class="jxr_linenumber" name="233" href="#233">233</a>         EasyMock.verify(mockBody);
<a class="jxr_linenumber" name="234" href="#234">234</a> 
<a class="jxr_linenumber" name="235" href="#235">235</a>         <strong class="jxr_keyword">if</strong> (reqCap.hasCaptured()) {
<a class="jxr_linenumber" name="236" href="#236">236</a>             <em class="jxr_comment">// backend request was made</em>
<a class="jxr_linenumber" name="237" href="#237">237</a>             <strong class="jxr_keyword">final</strong> HttpRequest forwarded = reqCap.getValue();
<a class="jxr_linenumber" name="238" href="#238">238</a>             Assert.assertNotNull(forwarded.getFirstHeader(<span class="jxr_string">"Content-Length"</span>));
<a class="jxr_linenumber" name="239" href="#239">239</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="240" href="#240">240</a>             <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">int</strong> status = result.getStatusLine().getStatusCode();
<a class="jxr_linenumber" name="241" href="#241">241</a>             Assert.assertTrue(HttpStatus.SC_LENGTH_REQUIRED == status
<a class="jxr_linenumber" name="242" href="#242">242</a>                     || HttpStatus.SC_BAD_REQUEST == status);
<a class="jxr_linenumber" name="243" href="#243">243</a>         }
<a class="jxr_linenumber" name="244" href="#244">244</a>     }
<a class="jxr_linenumber" name="245" href="#245">245</a> 
<a class="jxr_linenumber" name="246" href="#246">246</a>     <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="247" href="#247">247</a> <em class="jxr_comment">     * "If the OPTIONS request includes an entity-body (as indicated by the</em>
<a class="jxr_linenumber" name="248" href="#248">248</a> <em class="jxr_comment">     * presence of Content-Length or Transfer-Encoding), then the media type</em>
<a class="jxr_linenumber" name="249" href="#249">249</a> <em class="jxr_comment">     * MUST be indicated by a Content-Type field."</em>
<a class="jxr_linenumber" name="250" href="#250">250</a> <em class="jxr_comment">     *</em>
<a class="jxr_linenumber" name="251" href="#251">251</a> <em class="jxr_comment">     * <a href="http://www.w3.org/Protocols/rfc2616/rfc2616-sec9.html" target="alexandria_uri">http://www.w3.org/Protocols/rfc2616/rfc2616-sec9.html</a>#sec9.2</em>
<a class="jxr_linenumber" name="252" href="#252">252</a> <em class="jxr_comment">     */</em>
<a class="jxr_linenumber" name="253" href="#253">253</a>     @Test
<a class="jxr_linenumber" name="254" href="#254">254</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testOPTIONSRequestsWithBodiesAndNoContentTypeHaveOneSupplied() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="255" href="#255">255</a>         <strong class="jxr_keyword">final</strong> BasicHttpEntityEnclosingRequest options = <strong class="jxr_keyword">new</strong> BasicHttpEntityEnclosingRequest(<span class="jxr_string">"OPTIONS"</span>,
<a class="jxr_linenumber" name="256" href="#256">256</a>                 <span class="jxr_string">"/"</span>, HTTP_1_1);
<a class="jxr_linenumber" name="257" href="#257">257</a>         options.setEntity(body);
<a class="jxr_linenumber" name="258" href="#258">258</a>         options.setHeader(<span class="jxr_string">"Content-Length"</span>, <span class="jxr_string">"1"</span>);
<a class="jxr_linenumber" name="259" href="#259">259</a> 
<a class="jxr_linenumber" name="260" href="#260">260</a>         <strong class="jxr_keyword">final</strong> Capture&lt;HttpRequestWrapper&gt; reqCap = <strong class="jxr_keyword">new</strong> Capture&lt;HttpRequestWrapper&gt;();
<a class="jxr_linenumber" name="261" href="#261">261</a>         EasyMock.expect(
<a class="jxr_linenumber" name="262" href="#262">262</a>                 mockBackend.execute(
<a class="jxr_linenumber" name="263" href="#263">263</a>                         EasyMock.eq(route),
<a class="jxr_linenumber" name="264" href="#264">264</a>                         EasyMock.capture(reqCap),
<a class="jxr_linenumber" name="265" href="#265">265</a>                         EasyMock.isA(HttpClientContext.<strong class="jxr_keyword">class</strong>),
<a class="jxr_linenumber" name="266" href="#266">266</a>                         EasyMock.&lt;HttpExecutionAware&gt;isNull())).andReturn(originResponse);
<a class="jxr_linenumber" name="267" href="#267">267</a>         replayMocks();
<a class="jxr_linenumber" name="268" href="#268">268</a> 
<a class="jxr_linenumber" name="269" href="#269">269</a>         impl.execute(route, HttpRequestWrapper.wrap(options));
<a class="jxr_linenumber" name="270" href="#270">270</a> 
<a class="jxr_linenumber" name="271" href="#271">271</a>         verifyMocks();
<a class="jxr_linenumber" name="272" href="#272">272</a> 
<a class="jxr_linenumber" name="273" href="#273">273</a>         <strong class="jxr_keyword">final</strong> HttpRequest forwarded = reqCap.getValue();
<a class="jxr_linenumber" name="274" href="#274">274</a>         Assert.assertTrue(forwarded instanceof HttpEntityEnclosingRequest);
<a class="jxr_linenumber" name="275" href="#275">275</a>         <strong class="jxr_keyword">final</strong> HttpEntityEnclosingRequest reqWithBody = (HttpEntityEnclosingRequest) forwarded;
<a class="jxr_linenumber" name="276" href="#276">276</a>         <strong class="jxr_keyword">final</strong> HttpEntity reqBody = reqWithBody.getEntity();
<a class="jxr_linenumber" name="277" href="#277">277</a>         Assert.assertNotNull(reqBody);
<a class="jxr_linenumber" name="278" href="#278">278</a>         Assert.assertNotNull(reqBody.getContentType());
<a class="jxr_linenumber" name="279" href="#279">279</a>     }
<a class="jxr_linenumber" name="280" href="#280">280</a> 
<a class="jxr_linenumber" name="281" href="#281">281</a>     <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="282" href="#282">282</a> <em class="jxr_comment">     * "10.2.7 206 Partial Content ... The request MUST have included a Range</em>
<a class="jxr_linenumber" name="283" href="#283">283</a> <em class="jxr_comment">     * header field (section 14.35) indicating the desired range, and MAY have</em>
<a class="jxr_linenumber" name="284" href="#284">284</a> <em class="jxr_comment">     * included an If-Range header field (section 14.27) to make the request</em>
<a class="jxr_linenumber" name="285" href="#285">285</a> <em class="jxr_comment">     * conditional."</em>
<a class="jxr_linenumber" name="286" href="#286">286</a> <em class="jxr_comment">     *</em>
<a class="jxr_linenumber" name="287" href="#287">287</a> <em class="jxr_comment">     * <a href="http://www.w3.org/Protocols/rfc2616/rfc2616-sec10.html" target="alexandria_uri">http://www.w3.org/Protocols/rfc2616/rfc2616-sec10.html</a>#sec10.2.7</em>
<a class="jxr_linenumber" name="288" href="#288">288</a> <em class="jxr_comment">     */</em>
<a class="jxr_linenumber" name="289" href="#289">289</a>     @Test
<a class="jxr_linenumber" name="290" href="#290">290</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testPartialContentIsNotReturnedToAClientThatDidNotAskForIt() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="291" href="#291">291</a> 
<a class="jxr_linenumber" name="292" href="#292">292</a>         <em class="jxr_comment">// tester's note: I don't know what the cache will *do* in</em>
<a class="jxr_linenumber" name="293" href="#293">293</a>         <em class="jxr_comment">// this situation, but it better not just pass the response</em>
<a class="jxr_linenumber" name="294" href="#294">294</a>         <em class="jxr_comment">// on.</em>
<a class="jxr_linenumber" name="295" href="#295">295</a>         request.removeHeaders(<span class="jxr_string">"Range"</span>);
<a class="jxr_linenumber" name="296" href="#296">296</a>         originResponse = Proxies.enhanceResponse(
<a class="jxr_linenumber" name="297" href="#297">297</a>                 <strong class="jxr_keyword">new</strong> BasicHttpResponse(HTTP_1_1, HttpStatus.SC_PARTIAL_CONTENT,
<a class="jxr_linenumber" name="298" href="#298">298</a>                 <span class="jxr_string">"Partial Content"</span>));
<a class="jxr_linenumber" name="299" href="#299">299</a>         originResponse.setHeader(<span class="jxr_string">"Content-Range"</span>, <span class="jxr_string">"bytes 0-499/1234"</span>);
<a class="jxr_linenumber" name="300" href="#300">300</a>         originResponse.setEntity(makeBody(500));
<a class="jxr_linenumber" name="301" href="#301">301</a> 
<a class="jxr_linenumber" name="302" href="#302">302</a>         EasyMock.expect(
<a class="jxr_linenumber" name="303" href="#303">303</a>                 mockBackend.execute(
<a class="jxr_linenumber" name="304" href="#304">304</a>                         EasyMock.eq(route),
<a class="jxr_linenumber" name="305" href="#305">305</a>                         EasyMock.isA(HttpRequestWrapper.<strong class="jxr_keyword">class</strong>),
<a class="jxr_linenumber" name="306" href="#306">306</a>                         EasyMock.isA(HttpClientContext.<strong class="jxr_keyword">class</strong>),
<a class="jxr_linenumber" name="307" href="#307">307</a>                         EasyMock.&lt;HttpExecutionAware&gt;isNull())).andReturn(originResponse);
<a class="jxr_linenumber" name="308" href="#308">308</a> 
<a class="jxr_linenumber" name="309" href="#309">309</a>         replayMocks();
<a class="jxr_linenumber" name="310" href="#310">310</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="311" href="#311">311</a>             <strong class="jxr_keyword">final</strong> HttpResponse result = impl.execute(route, HttpRequestWrapper.wrap(request));
<a class="jxr_linenumber" name="312" href="#312">312</a>             Assert.assertTrue(HttpStatus.SC_PARTIAL_CONTENT != result.getStatusLine()
<a class="jxr_linenumber" name="313" href="#313">313</a>                     .getStatusCode());
<a class="jxr_linenumber" name="314" href="#314">314</a>         } <strong class="jxr_keyword">catch</strong> (<strong class="jxr_keyword">final</strong> ClientProtocolException acceptableBehavior) {
<a class="jxr_linenumber" name="315" href="#315">315</a>             <em class="jxr_comment">// this is probably ok</em>
<a class="jxr_linenumber" name="316" href="#316">316</a>         }
<a class="jxr_linenumber" name="317" href="#317">317</a>     }
<a class="jxr_linenumber" name="318" href="#318">318</a> 
<a class="jxr_linenumber" name="319" href="#319">319</a>     <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="320" href="#320">320</a> <em class="jxr_comment">     * "10.4.2 401 Unauthorized ... The response MUST include a WWW-Authenticate</em>
<a class="jxr_linenumber" name="321" href="#321">321</a> <em class="jxr_comment">     * header field (section 14.47) containing a challenge applicable to the</em>
<a class="jxr_linenumber" name="322" href="#322">322</a> <em class="jxr_comment">     * requested resource."</em>
<a class="jxr_linenumber" name="323" href="#323">323</a> <em class="jxr_comment">     *</em>
<a class="jxr_linenumber" name="324" href="#324">324</a> <em class="jxr_comment">     * <a href="http://www.w3.org/Protocols/rfc2616/rfc2616-sec10.html" target="alexandria_uri">http://www.w3.org/Protocols/rfc2616/rfc2616-sec10.html</a>#sec10.4.2</em>
<a class="jxr_linenumber" name="325" href="#325">325</a> <em class="jxr_comment">     */</em>
<a class="jxr_linenumber" name="326" href="#326">326</a>     @Test
<a class="jxr_linenumber" name="327" href="#327">327</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testPassesOnOrigin401ResponseWithoutWWWAuthenticateHeader() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="328" href="#328">328</a> 
<a class="jxr_linenumber" name="329" href="#329">329</a>         originResponse = Proxies.enhanceResponse(
<a class="jxr_linenumber" name="330" href="#330">330</a>                 <strong class="jxr_keyword">new</strong> BasicHttpResponse(HTTP_1_1, 401, <span class="jxr_string">"Unauthorized"</span>));
<a class="jxr_linenumber" name="331" href="#331">331</a> 
<a class="jxr_linenumber" name="332" href="#332">332</a>         EasyMock.expect(
<a class="jxr_linenumber" name="333" href="#333">333</a>                 mockBackend.execute(
<a class="jxr_linenumber" name="334" href="#334">334</a>                         EasyMock.eq(route),
<a class="jxr_linenumber" name="335" href="#335">335</a>                         EasyMock.isA(HttpRequestWrapper.<strong class="jxr_keyword">class</strong>),
<a class="jxr_linenumber" name="336" href="#336">336</a>                         EasyMock.isA(HttpClientContext.<strong class="jxr_keyword">class</strong>),
<a class="jxr_linenumber" name="337" href="#337">337</a>                         EasyMock.&lt;HttpExecutionAware&gt;isNull())).andReturn(originResponse);
<a class="jxr_linenumber" name="338" href="#338">338</a>         replayMocks();
<a class="jxr_linenumber" name="339" href="#339">339</a>         <strong class="jxr_keyword">final</strong> HttpResponse result = impl.execute(route, HttpRequestWrapper.wrap(request));
<a class="jxr_linenumber" name="340" href="#340">340</a>         verifyMocks();
<a class="jxr_linenumber" name="341" href="#341">341</a>         Assert.assertSame(originResponse, result);
<a class="jxr_linenumber" name="342" href="#342">342</a>     }
<a class="jxr_linenumber" name="343" href="#343">343</a> 
<a class="jxr_linenumber" name="344" href="#344">344</a>     <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="345" href="#345">345</a> <em class="jxr_comment">     * "10.4.6 405 Method Not Allowed ... The response MUST include an Allow</em>
<a class="jxr_linenumber" name="346" href="#346">346</a> <em class="jxr_comment">     * header containing a list of valid methods for the requested resource.</em>
<a class="jxr_linenumber" name="347" href="#347">347</a> <em class="jxr_comment">     *</em>
<a class="jxr_linenumber" name="348" href="#348">348</a> <em class="jxr_comment">     * <a href="http://www.w3.org/Protocols/rfc2616/rfc2616-sec10.html" target="alexandria_uri">http://www.w3.org/Protocols/rfc2616/rfc2616-sec10.html</a>#sec10.4.2</em>
<a class="jxr_linenumber" name="349" href="#349">349</a> <em class="jxr_comment">     */</em>
<a class="jxr_linenumber" name="350" href="#350">350</a>     @Test
<a class="jxr_linenumber" name="351" href="#351">351</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testPassesOnOrigin405WithoutAllowHeader() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="352" href="#352">352</a>         originResponse = Proxies.enhanceResponse(
<a class="jxr_linenumber" name="353" href="#353">353</a>                 <strong class="jxr_keyword">new</strong> BasicHttpResponse(HTTP_1_1, 405, <span class="jxr_string">"Method Not Allowed"</span>));
<a class="jxr_linenumber" name="354" href="#354">354</a> 
<a class="jxr_linenumber" name="355" href="#355">355</a>         EasyMock.expect(
<a class="jxr_linenumber" name="356" href="#356">356</a>                 mockBackend.execute(
<a class="jxr_linenumber" name="357" href="#357">357</a>                         EasyMock.eq(route),
<a class="jxr_linenumber" name="358" href="#358">358</a>                         EasyMock.isA(HttpRequestWrapper.<strong class="jxr_keyword">class</strong>),
<a class="jxr_linenumber" name="359" href="#359">359</a>                         EasyMock.isA(HttpClientContext.<strong class="jxr_keyword">class</strong>),
<a class="jxr_linenumber" name="360" href="#360">360</a>                         EasyMock.&lt;HttpExecutionAware&gt;isNull())).andReturn(originResponse);
<a class="jxr_linenumber" name="361" href="#361">361</a>         replayMocks();
<a class="jxr_linenumber" name="362" href="#362">362</a>         <strong class="jxr_keyword">final</strong> HttpResponse result = impl.execute(route, HttpRequestWrapper.wrap(request));
<a class="jxr_linenumber" name="363" href="#363">363</a>         verifyMocks();
<a class="jxr_linenumber" name="364" href="#364">364</a>         Assert.assertSame(originResponse, result);
<a class="jxr_linenumber" name="365" href="#365">365</a>     }
<a class="jxr_linenumber" name="366" href="#366">366</a> 
<a class="jxr_linenumber" name="367" href="#367">367</a>     <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="368" href="#368">368</a> <em class="jxr_comment">     * "10.4.8 407 Proxy Authentication Required ... The proxy MUST return a</em>
<a class="jxr_linenumber" name="369" href="#369">369</a> <em class="jxr_comment">     * Proxy-Authenticate header field (section 14.33) containing a challenge</em>
<a class="jxr_linenumber" name="370" href="#370">370</a> <em class="jxr_comment">     * applicable to the proxy for the requested resource."</em>
<a class="jxr_linenumber" name="371" href="#371">371</a> <em class="jxr_comment">     *</em>
<a class="jxr_linenumber" name="372" href="#372">372</a> <em class="jxr_comment">     * <a href="http://www.w3.org/Protocols/rfc2616/rfc2616-sec10.html" target="alexandria_uri">http://www.w3.org/Protocols/rfc2616/rfc2616-sec10.html</a>#sec10.4.8</em>
<a class="jxr_linenumber" name="373" href="#373">373</a> <em class="jxr_comment">     */</em>
<a class="jxr_linenumber" name="374" href="#374">374</a>     @Test
<a class="jxr_linenumber" name="375" href="#375">375</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testPassesOnOrigin407WithoutAProxyAuthenticateHeader() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="376" href="#376">376</a>         originResponse = Proxies.enhanceResponse(
<a class="jxr_linenumber" name="377" href="#377">377</a>                 <strong class="jxr_keyword">new</strong> BasicHttpResponse(HTTP_1_1, 407, <span class="jxr_string">"Proxy Authentication Required"</span>));
<a class="jxr_linenumber" name="378" href="#378">378</a> 
<a class="jxr_linenumber" name="379" href="#379">379</a>         EasyMock.expect(
<a class="jxr_linenumber" name="380" href="#380">380</a>                 mockBackend.execute(
<a class="jxr_linenumber" name="381" href="#381">381</a>                         EasyMock.eq(route),
<a class="jxr_linenumber" name="382" href="#382">382</a>                         EasyMock.isA(HttpRequestWrapper.<strong class="jxr_keyword">class</strong>),
<a class="jxr_linenumber" name="383" href="#383">383</a>                         EasyMock.isA(HttpClientContext.<strong class="jxr_keyword">class</strong>),
<a class="jxr_linenumber" name="384" href="#384">384</a>                         EasyMock.&lt;HttpExecutionAware&gt;isNull())).andReturn(originResponse);
<a class="jxr_linenumber" name="385" href="#385">385</a>         replayMocks();
<a class="jxr_linenumber" name="386" href="#386">386</a>         <strong class="jxr_keyword">final</strong> HttpResponse result = impl.execute(route, HttpRequestWrapper.wrap(request));
<a class="jxr_linenumber" name="387" href="#387">387</a>         verifyMocks();
<a class="jxr_linenumber" name="388" href="#388">388</a>         Assert.assertSame(originResponse, result);
<a class="jxr_linenumber" name="389" href="#389">389</a>     }
<a class="jxr_linenumber" name="390" href="#390">390</a> 
<a class="jxr_linenumber" name="391" href="#391">391</a> }
</pre>
<hr/><div id="footer">This page was automatically generated by <a href="http://maven.apache.org/">Maven</a></div></body>
</html>

